/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.util.Properties;

import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerOverwritePropertiesValue;
import jp.co.ntt.lms.installer.core.InstallerValues;

/**
 * メール設定ファイル書き換え入力項目を保持するクラス。
 * @author T.Nishiki
 */
public class MailInputValue implements InstallerOverwritePropertiesValue {
	/**
	 * メール設定ファイル・パスを取得するためのキー文字列。
	 */
	private static final String KEY_FILE = "mail";

	/**
	 * プロパティキー：SMTPホスト。
	 */
	public static final String KEY_SMTP_HOST = "SMTP_HOST";

	/**
	 * プロパティキー：SMTPポート番号。
	 */
	public static final String KEY_SMTP_PORT = "SMTP_PORT";

	/**
	 * プロパティキー：サイト管理用メールアドレス。
	 */
	public static final String KEY_SITE_MAILER_MAIL = "SITE_MAILER_MAIL";

	/**
	 * プロパティキー：送信元メールアドレス。
	 */
	public static final String KEY_MAIL_FROM = "MAIL_FROM";

	/**
	 * プロパティキー：サイト管理者用メールアドレス。
	 */
	public static final String KEY_SITE_ADMINISTRATOR_MAIL
			= "SITE_ADMINISTRATOR_MAIL";

	/**
	 * プロパティキー：ヘルプデスク用メールアドレス。
	 */
	public static final String KEY_HELPDESK_MAIL = "HELPDESK_MAIL";


	/**
	 * SMTPホスト名。
	 */
	private String _smtpHost;

	/**
	 * SMTPポート番号。
	 */
	private String _smtpPort;

	/**
	 * 送信元メールアドレス。
	 */
	private String _mailFrom;

	/**
	 * サイト管理者メールアドレス。
	 */
	private String _siteAdministratorMail;

	/**
	 * サイト・メールアドレス。
	 */
	private String _siteMailerMail;

	/**
	 * ヘルプデスク・メールアドレス。
	 */
	private String _helpdeskMail;

	/**
	 * SMTPホストを取得します。<br>
	 * @return SMTPホストを戻します。
	 */
	public String getSmtpHost() {
		return _smtpHost;
	}

	/**
	 * SMTPホストを設定します。
	 * @param smtpHost 設定するSMTPホスト。
	 */
	public void setSmtpHost(String smtpHost) {
		_smtpHost = smtpHost;
	}

	/**
	 * ヘルプデスク・メールアドレスを取得します。<br>
	 * @return ヘルプデスク・メールアドレスを戻します。
	 */
	public String getHelpdeskMail() {
		return _helpdeskMail;
	}

	/**
	 * SMTPポート番号を取得します。<br>
	 * @return SMTPポート番号を戻します。
	 */
	public String getSmtpPort() {
		return _smtpPort;
	}

	/**
	 * サイト管理用メールアドレスを取得します。<br>
	 * @return サイト管理用メールアドレスを戻します。
	 */
	public String getSiteMailerMail() {
		return _siteMailerMail;
	}

	/**
	 * サイト管理者メールアドレスを取得します。<br>
	 * @return サイト管理者メールアドレスを戻します。
	 */
	public String getSiteAdministratorMail() {
		return _siteAdministratorMail;
	}

	/**
	 * 送信元メールアドレスを取得します。<br>
	 * @return 送信元メールアドレスを戻します。
	 */
	public String getMailFrom() {
		return _mailFrom;
	}

	/**
	 * ヘルプデスク用メールアドレスを設定します。
	 * @param helpdeskMail ヘルプデスク用メールアドレス。
	 */
	public void setHelpdeskMail(String helpdeskMail) {
		_helpdeskMail = helpdeskMail;
	}

	/**
	 * SMTPポート番号を設定します。
	 * @param smtpPort 設定するSMTPポート番号。
	 */
	public void setSmtpPort(String smtpPort) {
		_smtpPort = smtpPort;
	}

	/**
	 * サイト管理用メールアドレスを設定します。
	 * @param siteMailerMail 設定するサイト管理用メールアドレス。
	 */
	public void setSiteMailerMail(String siteMailerMail) {
		_siteMailerMail = siteMailerMail;
	}

	/**
	 * サイト管理者用メールアドレスを設定します。
	 * @param siteAdministratorMail 設定するサイト管理者用メールアドレス。
	 */
	public void setSiteAdministratorMail(String siteAdministratorMail) {
		_siteAdministratorMail = siteAdministratorMail;
	}

	/**
	 * 送信元メールアドレス名を設定します。
	 * @param mailFrom 設定する送信元メールアドレス。
	 */
	public void setMailFrom(String mailFrom) {
		_mailFrom = mailFrom;
	}


	/**
	 * このクラスオブジェクトの文字列化します。<br>
	 * @return このクラスオブジェクトの文字列表現。
	 */
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("_smtpHost=" + _smtpHost);
		buffer.append(",_smtpPort=" + _smtpPort);
		buffer.append(",_mailFrom=" + _mailFrom);
		buffer.append(",_siteAdministratorMail=" + _siteAdministratorMail);
		buffer.append(",_siteMailerMail=" + _siteMailerMail);
		buffer.append(",_helpdeskMail=" + _helpdeskMail);
		return buffer.toString();
	}

	/**
	 * 上書きするプロパティ一覧を戻します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return 「上書きするプロパティのキー」と「その上書き後の値」を組とする
	 *          Propertiesを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	public Properties getOverwrittenProperties(InstallerValues values)
			throws InstallerException {
		Properties properties = new Properties();
		// SMTPホスト。
		properties.setProperty( KEY_SMTP_HOST, _smtpHost);
		// SMTPポート番号。
		properties.setProperty( KEY_SMTP_PORT, _smtpPort);
		// 送信元メールアドレス
		properties.setProperty( KEY_MAIL_FROM, _mailFrom);
		// サイト管理者用メールアドレス
		properties.setProperty(
			KEY_SITE_ADMINISTRATOR_MAIL, _siteAdministratorMail);
		// サイト管理用メールアドレス。
		properties.setProperty( KEY_SITE_MAILER_MAIL, _siteMailerMail);
		// ヘルプデスク用メールアドレス。
		properties.setProperty( KEY_HELPDESK_MAIL, _helpdeskMail);
		return properties;
	}

	/**
	 * プロパティファイル取得するためのキーを戻します。<br>
	 * プロパティファイルについて、インストール設定ファイルから
	 * 取得するためのキーを戻します。
	 * @return プロパティファイル取得用のキー文字列。
	 */
	public String getTargetFileKey() {
		return KEY_FILE;
	}

	/**
	 * 上書き対象のプロパティファイル(Native)を取得するためのキーを戻します。<br>
	 * 上書き対象のプロパティファイルを生成するための平文について、
	 * インストール設定ファイルから取得するためのキーを戻します。
	 * @return 上書き対象のプロパティファイル（Native）取得用のキー文字列。
	 */
	public String getTargetNativeFileKey() {
		return KEY_FILE + ".native";
	}
}
